# coding: utf-8

"""
    VMware Aria Automation Assembler IaaS API

    IAAS API is a RESTful service, which allows users to execute provisioning related UI actions via an API.  This page describes the RESTful APIs for IAAS API. The APIs facilitate CRUD operations on the various resources and entities used throughout VMware Aria Automation Assembler(Cloud Accounts, Cloud zones, Computes, Mappings, etc.) and allows operations on them (creating a cloud account, patching a machine, creating image progile, etc.).  The APIs that list collections of resources also support OData like implementation. Below query params can be used across different IAAS API endpoints  Example: 1. `$orderby` - returns a result with the rows being sorted by the values of provided attribute.     ```/iaas/api/cloud-accounts?$orderby=name%20desc```  2. `$top` -  number of records you want to get.     ```/iaas/api/cloud-accounts?$top=20```  3. `$skip` -  number of records you want to skip.      ```/iaas/api/cloud-accounts?$skip=10```  4. `$select` - select a subset of properties to include in the response.        ```/project-service/api/projects?$top=10&$skip=2```  5. `$filter` -  filter the results by a specified predicate expression. Operators: eq, ne, and, or.\\     ```/iaas/api/cloud-accounts?$filter=name%20eq%20'ABC*'``` - name starts with 'ABC'\\     ```/iaas/api/cloud-accounts?$filter=name%20eq%20'*ABC*'``` - name contains 'ABC'\\     ```/iaas/api/cloud-accounts?$filter=name%20eq%20'*ABC'``` - name ends with 'ABC'\\     /iaas/api/projects and /iaas/api/deployments support different format for partial match:\\     ```/iaas/api/projects?$filter=startswith(name, 'ABC')``` - name starts with 'ABC'\\     ```/iaas/api/projects?$filter=substringof('ABC', name``` - name contains 'ABC'\\     ```/iaas/api/projects?$filter=endswith(name, 'ABC')``` - name ends with 'ABC'\\     ```/iaas/api/cloud-accounts?$filter=name%20ne%20'example-cloud-account'%20or%20customProperties.isExternal%20eq%20'false'```  6. `$count` -  flag which when specified, regardless of the assigned value, shows the total number of records. If the collection has a filter it shows the number of records matching the filter.\\     ```/iaas/api/cloud-accounts?$count=true```   # noqa: E501

    OpenAPI spec version: 2021-07-15
    Contact: sales@vmware.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six

class InlineResponse20048(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'id': 'str',
        'created_at': 'str',
        'updated_at': 'str',
        'owner': 'str',
        'owner_type': 'str',
        'org_id': 'str',
        'links': 'object',
        'name': 'str',
        'description': 'str',
        'external_id': 'str',
        'start_ip_address': 'str',
        'end_ip_address': 'str',
        'ip_version': 'str',
        'tags': 'list[IaasapistorageprofilesidTags]',
        'dns_server_addresses': 'list[str]',
        'domain': 'str',
        'dns_search_domains': 'list[str]',
        'gateway_address': 'str',
        'subnet_prefix_length': 'int',
        'address_space_id': 'str',
        'integration_id': 'str'
    }

    attribute_map = {
        'id': 'id',
        'created_at': 'createdAt',
        'updated_at': 'updatedAt',
        'owner': 'owner',
        'owner_type': 'ownerType',
        'org_id': 'orgId',
        'links': '_links',
        'name': 'name',
        'description': 'description',
        'external_id': 'externalId',
        'start_ip_address': 'startIPAddress',
        'end_ip_address': 'endIPAddress',
        'ip_version': 'ipVersion',
        'tags': 'tags',
        'dns_server_addresses': 'dnsServerAddresses',
        'domain': 'domain',
        'dns_search_domains': 'dnsSearchDomains',
        'gateway_address': 'gatewayAddress',
        'subnet_prefix_length': 'subnetPrefixLength',
        'address_space_id': 'addressSpaceId',
        'integration_id': 'integrationId'
    }

    def __init__(self, id=None, created_at=None, updated_at=None, owner=None, owner_type=None, org_id=None, links=None, name=None, description=None, external_id=None, start_ip_address=None, end_ip_address=None, ip_version=None, tags=None, dns_server_addresses=None, domain=None, dns_search_domains=None, gateway_address=None, subnet_prefix_length=None, address_space_id=None, integration_id=None):  # noqa: E501
        """InlineResponse20048 - a model defined in Swagger"""  # noqa: E501
        self._id = None
        self._created_at = None
        self._updated_at = None
        self._owner = None
        self._owner_type = None
        self._org_id = None
        self._links = None
        self._name = None
        self._description = None
        self._external_id = None
        self._start_ip_address = None
        self._end_ip_address = None
        self._ip_version = None
        self._tags = None
        self._dns_server_addresses = None
        self._domain = None
        self._dns_search_domains = None
        self._gateway_address = None
        self._subnet_prefix_length = None
        self._address_space_id = None
        self._integration_id = None
        self.discriminator = None
        self.id = id
        if created_at is not None:
            self.created_at = created_at
        if updated_at is not None:
            self.updated_at = updated_at
        if owner is not None:
            self.owner = owner
        if owner_type is not None:
            self.owner_type = owner_type
        if org_id is not None:
            self.org_id = org_id
        self.links = links
        if name is not None:
            self.name = name
        if description is not None:
            self.description = description
        if external_id is not None:
            self.external_id = external_id
        self.start_ip_address = start_ip_address
        self.end_ip_address = end_ip_address
        if ip_version is not None:
            self.ip_version = ip_version
        if tags is not None:
            self.tags = tags
        if dns_server_addresses is not None:
            self.dns_server_addresses = dns_server_addresses
        if domain is not None:
            self.domain = domain
        if dns_search_domains is not None:
            self.dns_search_domains = dns_search_domains
        if gateway_address is not None:
            self.gateway_address = gateway_address
        self.subnet_prefix_length = subnet_prefix_length
        if address_space_id is not None:
            self.address_space_id = address_space_id
        if integration_id is not None:
            self.integration_id = integration_id

    @property
    def id(self):
        """Gets the id of this InlineResponse20048.  # noqa: E501

        The id of this resource instance  # noqa: E501

        :return: The id of this InlineResponse20048.  # noqa: E501
        :rtype: str
        """
        return self._id

    @id.setter
    def id(self, id):
        """Sets the id of this InlineResponse20048.

        The id of this resource instance  # noqa: E501

        :param id: The id of this InlineResponse20048.  # noqa: E501
        :type: str
        """
        if id is None:
            raise ValueError("Invalid value for `id`, must not be `None`")  # noqa: E501

        self._id = id

    @property
    def created_at(self):
        """Gets the created_at of this InlineResponse20048.  # noqa: E501

        Date when the entity was created. The date is in ISO 8601 and UTC.  # noqa: E501

        :return: The created_at of this InlineResponse20048.  # noqa: E501
        :rtype: str
        """
        return self._created_at

    @created_at.setter
    def created_at(self, created_at):
        """Sets the created_at of this InlineResponse20048.

        Date when the entity was created. The date is in ISO 8601 and UTC.  # noqa: E501

        :param created_at: The created_at of this InlineResponse20048.  # noqa: E501
        :type: str
        """

        self._created_at = created_at

    @property
    def updated_at(self):
        """Gets the updated_at of this InlineResponse20048.  # noqa: E501

        Date when the entity was last updated. The date is ISO 8601 and UTC.  # noqa: E501

        :return: The updated_at of this InlineResponse20048.  # noqa: E501
        :rtype: str
        """
        return self._updated_at

    @updated_at.setter
    def updated_at(self, updated_at):
        """Sets the updated_at of this InlineResponse20048.

        Date when the entity was last updated. The date is ISO 8601 and UTC.  # noqa: E501

        :param updated_at: The updated_at of this InlineResponse20048.  # noqa: E501
        :type: str
        """

        self._updated_at = updated_at

    @property
    def owner(self):
        """Gets the owner of this InlineResponse20048.  # noqa: E501

        Email of the user or display name of the group that owns the entity.  # noqa: E501

        :return: The owner of this InlineResponse20048.  # noqa: E501
        :rtype: str
        """
        return self._owner

    @owner.setter
    def owner(self, owner):
        """Sets the owner of this InlineResponse20048.

        Email of the user or display name of the group that owns the entity.  # noqa: E501

        :param owner: The owner of this InlineResponse20048.  # noqa: E501
        :type: str
        """

        self._owner = owner

    @property
    def owner_type(self):
        """Gets the owner_type of this InlineResponse20048.  # noqa: E501

        Type of a owner(user/ad_group) that owns the entity.  # noqa: E501

        :return: The owner_type of this InlineResponse20048.  # noqa: E501
        :rtype: str
        """
        return self._owner_type

    @owner_type.setter
    def owner_type(self, owner_type):
        """Sets the owner_type of this InlineResponse20048.

        Type of a owner(user/ad_group) that owns the entity.  # noqa: E501

        :param owner_type: The owner_type of this InlineResponse20048.  # noqa: E501
        :type: str
        """

        self._owner_type = owner_type

    @property
    def org_id(self):
        """Gets the org_id of this InlineResponse20048.  # noqa: E501

        The id of the organization this entity belongs to.  # noqa: E501

        :return: The org_id of this InlineResponse20048.  # noqa: E501
        :rtype: str
        """
        return self._org_id

    @org_id.setter
    def org_id(self, org_id):
        """Sets the org_id of this InlineResponse20048.

        The id of the organization this entity belongs to.  # noqa: E501

        :param org_id: The org_id of this InlineResponse20048.  # noqa: E501
        :type: str
        """

        self._org_id = org_id

    @property
    def links(self):
        """Gets the links of this InlineResponse20048.  # noqa: E501

        hrefs links  # noqa: E501

        :return: The links of this InlineResponse20048.  # noqa: E501
        :rtype: object
        """
        return self._links

    @links.setter
    def links(self, links):
        """Sets the links of this InlineResponse20048.

        hrefs links  # noqa: E501

        :param links: The links of this InlineResponse20048.  # noqa: E501
        :type: object
        """
        if links is None:
            raise ValueError("Invalid value for `links`, must not be `None`")  # noqa: E501

        self._links = links

    @property
    def name(self):
        """Gets the name of this InlineResponse20048.  # noqa: E501

        A human-friendly name used as an identifier in APIs that support this option.  # noqa: E501

        :return: The name of this InlineResponse20048.  # noqa: E501
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name):
        """Sets the name of this InlineResponse20048.

        A human-friendly name used as an identifier in APIs that support this option.  # noqa: E501

        :param name: The name of this InlineResponse20048.  # noqa: E501
        :type: str
        """

        self._name = name

    @property
    def description(self):
        """Gets the description of this InlineResponse20048.  # noqa: E501

        A human-friendly description.  # noqa: E501

        :return: The description of this InlineResponse20048.  # noqa: E501
        :rtype: str
        """
        return self._description

    @description.setter
    def description(self, description):
        """Sets the description of this InlineResponse20048.

        A human-friendly description.  # noqa: E501

        :param description: The description of this InlineResponse20048.  # noqa: E501
        :type: str
        """

        self._description = description

    @property
    def external_id(self):
        """Gets the external_id of this InlineResponse20048.  # noqa: E501

        External entity Id on the provider side.  # noqa: E501

        :return: The external_id of this InlineResponse20048.  # noqa: E501
        :rtype: str
        """
        return self._external_id

    @external_id.setter
    def external_id(self, external_id):
        """Sets the external_id of this InlineResponse20048.

        External entity Id on the provider side.  # noqa: E501

        :param external_id: The external_id of this InlineResponse20048.  # noqa: E501
        :type: str
        """

        self._external_id = external_id

    @property
    def start_ip_address(self):
        """Gets the start_ip_address of this InlineResponse20048.  # noqa: E501

        Start IP address of the range.  # noqa: E501

        :return: The start_ip_address of this InlineResponse20048.  # noqa: E501
        :rtype: str
        """
        return self._start_ip_address

    @start_ip_address.setter
    def start_ip_address(self, start_ip_address):
        """Sets the start_ip_address of this InlineResponse20048.

        Start IP address of the range.  # noqa: E501

        :param start_ip_address: The start_ip_address of this InlineResponse20048.  # noqa: E501
        :type: str
        """
        if start_ip_address is None:
            raise ValueError("Invalid value for `start_ip_address`, must not be `None`")  # noqa: E501

        self._start_ip_address = start_ip_address

    @property
    def end_ip_address(self):
        """Gets the end_ip_address of this InlineResponse20048.  # noqa: E501

        End IP address of the range.  # noqa: E501

        :return: The end_ip_address of this InlineResponse20048.  # noqa: E501
        :rtype: str
        """
        return self._end_ip_address

    @end_ip_address.setter
    def end_ip_address(self, end_ip_address):
        """Sets the end_ip_address of this InlineResponse20048.

        End IP address of the range.  # noqa: E501

        :param end_ip_address: The end_ip_address of this InlineResponse20048.  # noqa: E501
        :type: str
        """
        if end_ip_address is None:
            raise ValueError("Invalid value for `end_ip_address`, must not be `None`")  # noqa: E501

        self._end_ip_address = end_ip_address

    @property
    def ip_version(self):
        """Gets the ip_version of this InlineResponse20048.  # noqa: E501

        IP address version: IPv4 or IPv6. Default: IPv4.  # noqa: E501

        :return: The ip_version of this InlineResponse20048.  # noqa: E501
        :rtype: str
        """
        return self._ip_version

    @ip_version.setter
    def ip_version(self, ip_version):
        """Sets the ip_version of this InlineResponse20048.

        IP address version: IPv4 or IPv6. Default: IPv4.  # noqa: E501

        :param ip_version: The ip_version of this InlineResponse20048.  # noqa: E501
        :type: str
        """
        allowed_values = ["IPv4", "IPv6"]  # noqa: E501
        if ip_version not in allowed_values:
            raise ValueError(
                "Invalid value for `ip_version` ({0}), must be one of {1}"  # noqa: E501
                .format(ip_version, allowed_values)
            )

        self._ip_version = ip_version

    @property
    def tags(self):
        """Gets the tags of this InlineResponse20048.  # noqa: E501

        A set of tag keys and optional values that were set on this resource instance.  # noqa: E501

        :return: The tags of this InlineResponse20048.  # noqa: E501
        :rtype: list[IaasapistorageprofilesidTags]
        """
        return self._tags

    @tags.setter
    def tags(self, tags):
        """Sets the tags of this InlineResponse20048.

        A set of tag keys and optional values that were set on this resource instance.  # noqa: E501

        :param tags: The tags of this InlineResponse20048.  # noqa: E501
        :type: list[IaasapistorageprofilesidTags]
        """

        self._tags = tags

    @property
    def dns_server_addresses(self):
        """Gets the dns_server_addresses of this InlineResponse20048.  # noqa: E501

        DNS IP addresses of the range.  # noqa: E501

        :return: The dns_server_addresses of this InlineResponse20048.  # noqa: E501
        :rtype: list[str]
        """
        return self._dns_server_addresses

    @dns_server_addresses.setter
    def dns_server_addresses(self, dns_server_addresses):
        """Sets the dns_server_addresses of this InlineResponse20048.

        DNS IP addresses of the range.  # noqa: E501

        :param dns_server_addresses: The dns_server_addresses of this InlineResponse20048.  # noqa: E501
        :type: list[str]
        """

        self._dns_server_addresses = dns_server_addresses

    @property
    def domain(self):
        """Gets the domain of this InlineResponse20048.  # noqa: E501

        DNS domain of the range.  # noqa: E501

        :return: The domain of this InlineResponse20048.  # noqa: E501
        :rtype: str
        """
        return self._domain

    @domain.setter
    def domain(self, domain):
        """Sets the domain of this InlineResponse20048.

        DNS domain of the range.  # noqa: E501

        :param domain: The domain of this InlineResponse20048.  # noqa: E501
        :type: str
        """

        self._domain = domain

    @property
    def dns_search_domains(self):
        """Gets the dns_search_domains of this InlineResponse20048.  # noqa: E501

        DNS domain search (in order)  # noqa: E501

        :return: The dns_search_domains of this InlineResponse20048.  # noqa: E501
        :rtype: list[str]
        """
        return self._dns_search_domains

    @dns_search_domains.setter
    def dns_search_domains(self, dns_search_domains):
        """Sets the dns_search_domains of this InlineResponse20048.

        DNS domain search (in order)  # noqa: E501

        :param dns_search_domains: The dns_search_domains of this InlineResponse20048.  # noqa: E501
        :type: list[str]
        """

        self._dns_search_domains = dns_search_domains

    @property
    def gateway_address(self):
        """Gets the gateway_address of this InlineResponse20048.  # noqa: E501

        The gateway address of the range  # noqa: E501

        :return: The gateway_address of this InlineResponse20048.  # noqa: E501
        :rtype: str
        """
        return self._gateway_address

    @gateway_address.setter
    def gateway_address(self, gateway_address):
        """Sets the gateway_address of this InlineResponse20048.

        The gateway address of the range  # noqa: E501

        :param gateway_address: The gateway_address of this InlineResponse20048.  # noqa: E501
        :type: str
        """

        self._gateway_address = gateway_address

    @property
    def subnet_prefix_length(self):
        """Gets the subnet_prefix_length of this InlineResponse20048.  # noqa: E501

        Subnet prefix length (synonymous with \"netmask\")  # noqa: E501

        :return: The subnet_prefix_length of this InlineResponse20048.  # noqa: E501
        :rtype: int
        """
        return self._subnet_prefix_length

    @subnet_prefix_length.setter
    def subnet_prefix_length(self, subnet_prefix_length):
        """Sets the subnet_prefix_length of this InlineResponse20048.

        Subnet prefix length (synonymous with \"netmask\")  # noqa: E501

        :param subnet_prefix_length: The subnet_prefix_length of this InlineResponse20048.  # noqa: E501
        :type: int
        """
        if subnet_prefix_length is None:
            raise ValueError("Invalid value for `subnet_prefix_length`, must not be `None`")  # noqa: E501

        self._subnet_prefix_length = subnet_prefix_length

    @property
    def address_space_id(self):
        """Gets the address_space_id of this InlineResponse20048.  # noqa: E501

        Address space that the range belongs to  # noqa: E501

        :return: The address_space_id of this InlineResponse20048.  # noqa: E501
        :rtype: str
        """
        return self._address_space_id

    @address_space_id.setter
    def address_space_id(self, address_space_id):
        """Sets the address_space_id of this InlineResponse20048.

        Address space that the range belongs to  # noqa: E501

        :param address_space_id: The address_space_id of this InlineResponse20048.  # noqa: E501
        :type: str
        """

        self._address_space_id = address_space_id

    @property
    def integration_id(self):
        """Gets the integration_id of this InlineResponse20048.  # noqa: E501

        ID of the IPAM integration this IP range belongs to  # noqa: E501

        :return: The integration_id of this InlineResponse20048.  # noqa: E501
        :rtype: str
        """
        return self._integration_id

    @integration_id.setter
    def integration_id(self, integration_id):
        """Sets the integration_id of this InlineResponse20048.

        ID of the IPAM integration this IP range belongs to  # noqa: E501

        :param integration_id: The integration_id of this InlineResponse20048.  # noqa: E501
        :type: str
        """

        self._integration_id = integration_id

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(InlineResponse20048, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, InlineResponse20048):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
